﻿class Bus
{
	public static var TEMPS_ARRET:Number = 3000; // Temps pendant lequel le bus va s'arreter à un arret ou il y a du monde en attente en ms.
	private var m_arrets:Array; // Suite triée des arrets auxquelles s'arrete le bus.
	private var m_nom_guidebase:String; // Nom du guide qui a servit à créer le guide du bus
	private var m_nom_guideline:String; // Le guide du bus, copie du guide de base
	private var m_nb_frames:Number; // Le nombre de frame séparant 2 arrets sur le guide pour la ligne sur laquelle se déplace ce bus (donnée du xml).
	private var m_nb_passagers:Number; // Le nombre de passager que contenait le bus lors du dernier rafrachissement.
	
	public function Bus(nom_guidebase:String, nom_guideline:String, nb_frames:Number)
	{
		m_arrets = new Array();
		m_nom_guideline = nom_guideline;
		m_nom_guidebase = nom_guidebase;
		m_nb_frames = nb_frames;
	}
	
	public function initArretArrivee()
	{
		// Pour chaque passagers que ce bus va prendre.
		for(var i:Number = 0; i < m_arrets.length; i++)
		{
			for(var j:Number = 0; j  < m_arrets[i].passagers.length; j++)
			{
				// Calcul aléatoire de l'arret d'arrivée.
				var index:Number = i;
				var a:Number = Math.random()*(m_arrets.length - 1 - index);
				var b:Number = Math.floor(a) + 1 + index;
				m_arrets[i].passagers[j].indiceArrivee = m_arrets[b].indice;
				
				// On associe les positions des arrets de départ et d'arrivée
				_root.carteswf[m_nom_guidebase].gotoAndStop(m_arrets[i].passagers[j].indiceDepart * m_nb_frames + 1);
				m_arrets[i].passagers[j].xDepart = _root.carteswf[m_nom_guidebase]["bus"]._x + random(Passager.AIRE_PLACEMENT) - Passager.AIRE_PLACEMENT/2;
				m_arrets[i].passagers[j].yDepart = _root.carteswf[m_nom_guidebase]["bus"]._y + random(Passager.AIRE_PLACEMENT) - Passager.AIRE_PLACEMENT/2;
				//trace("guide = " + _root.carteswf[m_nom_guidebase]);
				//trace("indice depart " + m_arrets[i].passagers[j].indiceDepart + "   frame = " + _root.carteswf[m_nom_guidebase]._currentframe);
				//trace(" x depart = " +_root.carteswf[m_nom_guidebase]["bus"]._x);
				
				_root.carteswf[m_nom_guidebase].gotoAndStop(m_arrets[i].passagers[j].indiceArrivee * m_nb_frames + 1);
				m_arrets[i].passagers[j].xArrivee = _root.carteswf[m_nom_guidebase]["bus"]._x + random(Passager.AIRE_PLACEMENT) - Passager.AIRE_PLACEMENT/2;
				m_arrets[i].passagers[j].yArrivee = _root.carteswf[m_nom_guidebase]["bus"]._y + random(Passager.AIRE_PLACEMENT) - Passager.AIRE_PLACEMENT/2;
				//trace("indice arrivee " + m_arrets[i].passagers[j].indiceArrivee + "   frame = " + _root.carteswf[m_nom_guidebase]._currentframe);
				//trace(" x arrivee = " +_root.carteswf[m_nom_guidebase]["bus"]._x + "\n\n");
				
				// On défini les heures de départ et d'arrivée de chaque passager
				m_arrets[i].passagers[j].heureDepart = m_arrets[i].heure;
				m_arrets[i].passagers[j].heureArrivee = m_arrets[b].heure;
				
				// On crée le movie clip du passager
				_global.hauteur++;
				_root.carteswf[m_nom_guideline].attachMovie("passagerPopup", "passagerPopup"+_global.hauteur, _global.hauteur);
				_root.carteswf[m_nom_guideline]["passagerPopup"+_global.hauteur].passager.gotoAndStop(m_arrets[i].passagers[j].type);
				m_arrets[i].passagers[j].clip = _root.carteswf[m_nom_guideline]["passagerPopup"+_global.hauteur];
				_root.carteswf[m_nom_guideline]["passagerPopup"+_global.hauteur]._visible = false;
			}
		}
	}
	
	/**
	*	Ajouter un arret à la liste des arrets auxquelle le bus s'arrete
	*/
	public function addArret(a:Arret)
	{
		// Ajoute de l'arret
		m_arrets.push(a);
		
		// Tri de la liste par indice d'arret
		m_arrets.sort(order);
	}
	
	// Fonction de tri personalisée
	private function order(a:Arret, b:Arret):Number
	{
		// Ne demandez pas pourquoi parseInt... sans on se retrouve 
		// avec 10 < 2 par exemple : l'ordre alphanumérique apparement...
		if(a.indice < b.indice)
			return -1;
		else if (a.indice == b.indice)
			return 0;
		else
			return 1;
	}
	
	/**
	* 	Accesseur
	*/
	public function get arrets():Array
	{
		return m_arrets;
	}
	
	public function toString():String
	{
		var s = "";
		for(var i = 0; i < m_arrets.length; i++)
		{
			s += m_arrets[i].toString()+"\n";
		}
		return s;
	}
	
	/**
	*	Fonction permettant de placer le bus ainsi que l'ensemble de ses passagers
	*	à la bonne position et visible/invisible s'il le faut.
	*/
	public function rafraichir(h:Number)
	{
		var depart_etape:Arret;
		var arrivee_etape:Arret;
		
		// Si l'heure de départ au premier arret n'est pas atteinte ou si l'heure
		// d'arrivée au dernier arret est dépassé alors le bus ne doit pas etre affiché.
		if(h < m_arrets[0].heure || h > m_arrets[m_arrets.length - 1].heure || m_arrets.length < 2)
		{
			// Le bus n'est pas encore affiché.
			_root.carteswf[m_nom_guideline]._visible = false;
			//trace("pasbon : " + h + " " + m_arrets[0].heure + " " + m_arrets[m_arrets.length - 1].heure + " " + m_nom_guideline);
		}
		else
		{
			// Le bus est sur la ligne il doit etre affiché.
			_root.carteswf[m_nom_guideline]._visible = true;
			//trace("bon : " + h + " " + m_arrets[0].heure + " " + m_arrets[m_arrets.length - 1].heure + " " + m_nom_guideline);
			
			// Recherche des arrets de départ et d'arrivée pour l'interpolation.
			for(var i = 0; i < m_arrets.length && depart_etape == undefined; i++)
			{
				if(h < m_arrets[i].heure)
				{
					if(h - m_arrets[i-1].heure < TEMPS_ARRET)
					{
						// Cas ou le bus est à l'arret et fait monter les passagers, il est arreté.
						depart_etape = m_arrets[i-1];
						arrivee_etape = m_arrets[i-1];
					}
					else
					{
						depart_etape = m_arrets[i-1];
						arrivee_etape = m_arrets[i];
					}
				}
			}
			
			// Interpolation
			var nb_frames_interpol = m_nb_frames * (arrivee_etape.indice - depart_etape.indice);
			var tps_interpol = arrivee_etape.heure - (depart_etape.heure + TEMPS_ARRET);
			var rapport = (h - (depart_etape.heure + TEMPS_ARRET)) / tps_interpol;
			var decalage_frames = Math.floor(rapport * nb_frames_interpol);
			
			// Positionnement du guide à la bonne frame.
			_root.carteswf[m_nom_guideline].gotoAndStop(depart_etape.indice * m_nb_frames + decalage_frames + 1);
			
			depart_etape = undefined;
		}
		
		// Rendu des passagers
		// Placement et affichage des passagers et calcul du nombre de passager dans le bus.
		m_nb_passagers = 0;
		for(var i:Number = 0; i < m_arrets.length; i++)
		{
			for(var j:Number = 0; j  < m_arrets[i].passagers.length; j++)
			{
				// Si rafraichir retourne true c'est que le passager est dans le bus (il n'est pas affiché sur la carte)
				if(m_arrets[i].passagers[j].rafraichir(h))
				{
					m_nb_passagers++;
				}
			}
		}
		
		// Affectation au bus du nombre de passager qu'il contient pour le popup.
		_root.carteswf[m_nom_guideline].bus.nbPassagers = m_nb_passagers;
	}
}
