﻿class Passager
{
	public static var TEMPS_AVANCE:Number = 30000; // Avance avec laquelle le passager arrive à l'arret de départ (exprimée en ms).
	public static var TEMPS_ARRIVEE:Number = 30000; // Temps pendant lequel le passager reste à l'arret d'arrivé.
	public static var AIRE_PLACEMENT:Number = 50; // Coté du carré dans lequel les passagers peuvent apparaitre aléatoirement autour d'un arret (le carré est centré sur la position de l'arret).
	private var m_type:Number; // Type du passager, donnée xml
	private var m_indice_depart:Number; // L'indice de l'arret de départ, indice réel du xml
	private var m_indice_arrivee:Number; // L'indice de l'arret d'arrivée (calculé aléatoirement dans les arrets suivants l'arret de départ)
	private var m_x_depart:Number; // La position x de l'arret de départ
	private var m_y_depart:Number; // La position y de l'arret de départ
	private var m_x_arrivee:Number; // La position x de l'arret d'arrivée
	private var m_y_arrivee:Number; // La position y de l'arret d'arrivée
	private var m_heure_depart:Number; // L'heure à laquelle le bus qui prend le passager arrive à l'arret de départ
	private var m_heure_arrivee:Number; // L'heure à laquelle le bus qui fait descendre le passager arrive à l'arret de départ
	private var m_instance:Boolean = false; // True si le clip du passager a été instancié, false s'il ne l'est pas encore
	private var m_mc:MovieClip; // Le clip du passager
	
	/**
	*	Rafraichissement de la position et du caractère visible/invisible
	*	des passagers fonction de l'heure.
	*/
	public function rafraichir(h:Number):Boolean
	{
		if((m_heure_depart - TEMPS_AVANCE) <= h && h < m_heure_depart)
		{
			// Cas ou le passager attend à son arret de départ
			m_mc._visible = true;
			
			// On place le passager en attente à son arret de départ
			m_mc._x = m_x_depart;
			m_mc._y = m_y_depart;

			return false;
		}
		else if(m_heure_arrivee < h && h <= (m_heure_arrivee + TEMPS_ARRIVEE))
		{
			// Cas ou le passager vient de descendre à l'arret d'arrivée
			m_mc._visible = true;
			
			// On place le passager en attente à son arret d'arrivée
			m_mc._x = m_x_arrivee;
			m_mc._y = m_y_arrivee;
			
			return false;
		}
		else if(m_heure_depart <= h && h <= m_heure_arrivee)
		{
			// Cas ou il est dans le bus, on retourne true pour signaler qu'il est dans le bus
			m_mc._visible = false;
			
			return true;
		}
		else
		{
			// Le passager n'est plus affiché et n'est pas dans le bus
			m_mc._visible = false;
			
			return false;
		}
	}
	
	/**
	*	Acesseurs
	*/
	public function set clip(mc:MovieClip)
	{
		m_mc = mc;
	}
	
	public function get clip():MovieClip
	{
		return m_mc;
	}
	
	public function set heureDepart(heure_depart:Number)
	{
		m_heure_depart = heure_depart;
	}
		
	public function set heureArrivee(heure_arrivee:Number)
	{
		m_heure_arrivee = heure_arrivee;
	}
	
	public function set xDepart(x_depart:Number)
	{
		m_x_depart = x_depart;
	}
	
	public function set yDepart(y_depart:Number)
	{
		m_y_depart = y_depart;
	}
	
	public function set xArrivee(x_arrivee:Number)
	{
		m_x_arrivee = x_arrivee;
	}
	
	public function set yArrivee(y_arrivee:Number)
	{
		m_y_arrivee = y_arrivee;
	}
	
	public function Passager(type_passager:Number)
	{
		m_type = type_passager;
	}
	
	public function get type():Number
	{
		return m_type;
	}
	
	public function get indiceDepart():Number
	{
		return m_indice_depart;
	}
		
	public function get indiceArrivee():Number
	{
		return m_indice_arrivee;
	}
	
	public function set indiceDepart(i:Number)
	{
		m_indice_depart = i;
	}
	
	public function set indiceArrivee(i:Number)
	{
		m_indice_arrivee = i;
	}
	
	public function toString():String
	{
		return "Passager type " + m_type + " va de " + m_indice_depart + " a " + m_indice_arrivee + " heures " + m_heure_depart + " " + m_heure_arrivee + " mc " + m_mc;
	}
}
